searchData={"items":[{"type":"module","title":"Pinegeist","doc":"Documentation for `Pinegeist`. To get started, check the [Overview Guide](overview.html).","ref":"Pinegeist.html"},{"type":"function","title":"Pinegeist.island/1","doc":"Renders an Alpine component.","ref":"Pinegeist.html#island/1"},{"type":"function","title":"Attributes - Pinegeist.island/1","doc":"* `id` (`:string`) (required) - Unique identifier for the island component.","ref":"Pinegeist.html#island/1-attributes"},{"type":"function","title":"Slots - Pinegeist.island/1","doc":"* `prop` - Declare a reactive data in Alpine. The value will be synchronized with the server side LiveView state. Accepts attributes:\n\n  * `name` (`:string`) (required) - The property name of the reactive data. You can access it via `$props` Alpine magic.\n  * `value` (`:any`) (required) - The value of the reactive data. It must be a JSON serializable value.\n* `inner_block` (required) - The content rendered inside the island. It will ignore LiveView DOM updates and should be managed by Alpine.","ref":"Pinegeist.html#island/1-slots"},{"type":"function","title":"Examples - Pinegeist.island/1","doc":"A simple counter which has a `count` property lives in Alpine reactive data and is synchronized with the server side LiveView state.\n\n```heex\n<.island id=\"counter-example\">\n  <:prop name=\"count\" value={@count} />\n   \n    count:  <%= @count %> \n   \n</.island>\n```","ref":"Pinegeist.html#island/1-examples"},{"type":"extras","title":"Overview","doc":"# Overview\n\nPinegeist offers seamless integration of [Alpine.js](https://alpinejs.dev/) with [Phoenix LiveView](https://hexdocs.pm/phoenix_live_view/welcome.html), enhancing the client-side interactivity of LiveView applications.\n\nTypically, the integration is achieved by tapping into LiveView's DOM patching lifecycle to reconcile Alpine changes with LiveView updates. However, Pinegeist takes a different approach by rendering Alpine component inside an \"isolated island\", which ignores any LiveView DOM updates and is completely managed by Alpine.\n\nThis allows you to use Alpine to implement interactive UI components with complex client-side states, rendering theme inside an island that won't be affected by LiveView. Additionally, Pinegeist provides utilities for Alpine components to communicate with LiveView, enabling interaction with server-side state when needed.\n\n# Installation\n\nThe package can be installed by adding pinegeist to your list of dependencies in mix.exs:\n\n```elixir\ndef deps do\n  [\n    {:pinegeist, \"~> 0.2.1\"}\n  ]\nend\n```","ref":"overview.html"},{"type":"extras","title":"Integrations","doc":"# Integrations","ref":"alpine-integration.html"}],"content_type":"text/markdown","producer":{"name":"ex_doc","version":[48,46,51,50,46,50]}}